#coding: utf-8
#'illustration de l'addition de nombres relatifs
# des nombres entiers relatifs sont demandÃ©s (dans des cadres) pour en faire l'addition
# les boules rouges reprÃ©sentent les nombres positifs,
# des boules bleues reprÃ©sentent les nombres nÃ©gatifs
# les boules se dÃ©placent et disparaissent lors de chocs de couleurs opposÃ©es
# jusqu'à  ce que ne reste qu'une couleur
# le résultat de l'addition est alors annoncée
import pygame.mixer
from tkinter import *
from time import time, sleep
import random
delai=100

def creerBulle(x,y,couleur,vitinit):
    global rayon,bulles,xBulle,yBulle,vxBulle,vyBulle,couleurBulle
    xBulle.append(x)
    yBulle.append(y)
    vxBulle.append(vitinit*(-1)**random.randrange(1,10))
    vyBulle.append(vitinit*(-1)**random.randrange(1,10))
    couleurBulle.append(couleur)
    bulles.append(canv.create_oval(xBulle[-1]-rayon,yBulle[-1]-rayon,xBulle[-1]+rayon,yBulle[-1]+rayon,fill=couleurBulle[-1]))

def rebond(k,m):
    #version naive
    if vxBulle[k]*vxBulle[m]<0 and vyBulle[k]*vyBulle[m]<0:
        vxBulle[k]=-vxBulle[k]
        vxBulle[m]=-vxBulle[m]
    if vxBulle[k]*vxBulle[m]<0 and vyBulle[k]*vyBulle[m]>0:
        vxBulle[k]=-vxBulle[k]
        vxBulle[m]=-vxBulle[m]
    if vxBulle[k]*vxBulle[m]>0 and vyBulle[k]*vyBulle[m]>0:
        vyBulle[k]=-vyBulle[k]
        vyBulle[m]=-vyBulle[m]


#def ajouter(evt):
#    global liste
#    if evt.keysym not in liste:
#        liste.append(evt.keysym)

#def soustraire(evt):
#    global liste
#    if evt.keysym in liste:
#        liste.remove(evt.keysym)


def animer():
    global compteur,delai,blop,tour,debut,vitinit,fin,positif, negatif,vxBulle,vyBulle,couleurBulle,perdu,rayon,xBulle,yBulle,bulles,rayon,xBalle,yBalle
    asupprimer=[]
    for k in range(len(bulles)):
        if xBulle[k]+1<rayon:
            vxBulle[k]=-vxBulle[k]
            xBulle[k]+=3
            toc.play()
        if yBulle[k]+1<rayon:
            vyBulle[k]=-vyBulle[k]
            yBulle[k]+=3
            toc.play()
        if xBulle[k]>799-rayon:
            vxBulle[k]=-vxBulle[k]
            xBulle[k]-=3
            toc.play()
        if yBulle[k]>599-rayon:
            yBulle[k]-=3
            vyBulle[k]=-vyBulle[k]
            toc.play()
        #les bulles se déplacent
        xBulle[k]+=vxBulle[k]
        yBulle[k]+=vyBulle[k]
        canv.coords(bulles[k],xBulle[k]-rayon,yBulle[k]-rayon,xBulle[k]+rayon,yBulle[k]+rayon)
    #on supprime les bulles de meme couleur qui se touchent.
    for k in range(len(bulles)-1):
        test=0
        for m in range(k+1, len(bulles)):
            if ((xBulle[m]-xBulle[k])**2+(yBulle[m]-yBulle[k])**2)<(2*rayon+1)**2:
                if couleurBulle[k]!=couleurBulle[m]:
                    if test==0:
                        asupprimer.append(k)
                        asupprimer.append(m)
                        positif-=1
                        negatif-=1
                        test=1
                        blop.play()
        if test==1:
            print(k,'',m)
            for n in (max(asupprimer),min(asupprimer)):
                canv.delete(bulles[n])
                bulles.pop(n)
                xBulle.pop(n)
                yBulle.pop(n)
                couleurBulle.pop(n)
                vxBulle.pop(n)
                vyBulle.pop(n)
    #les bulles de meme couleur qui se touchent rebondissent
    for k in range(len(bulles)-1):
        for m in range(k+1, len(bulles)):
            if ((xBulle[m]-xBulle[k])**2+(yBulle[m]-yBulle[k])**2)<(2*rayon+1)**2:
                if couleurBulle[k]==couleurBulle[m]:
                    rebond(k,m)
                    if ((xBulle[m]-xBulle[k])**2+(yBulle[m]-yBulle[k])**2)<(2*rayon)**2:
                        if xBulle[m]>rayon+5 and xBulle[m]<xBulle[k]:
                            xBulle[m]-=4
                        elif xBulle[m]>xBulle[k] and xBulle[m]<795-rayon:
                            xBulle[m]+=4
    if positif==0 or negatif==0:
        perdu=1
    if not perdu:
        tour=0
        if positif+negatif<5 or (positif<=2 or negatif<=2):
            delai=max(delai-5,50)
            compteur+=1
            compteur=compteur%5
            if compteur==0:
                rayon=min(rayon+1,80)
        fenetre.after(delai,animer)
    else:
        delai = 50
        tour+=1
        if positif+negatif!=0:
            texte.append(canv.create_text(400,300,text="Il n'y a qu'une couleur, le calcul est fini.",font=('Arial',20),fill='green'))
        else:
            texte.append(canv.create_text(400,300,text="Il n'y a plus rien, le calcul est fini.",font=('Arial',20),fill='green'))
        if tour==70:
            gameOver()
        else:
            fenetre.after(delai,animer)

def gameOver():
    global bulles,rayon,debut,n1,n2
    for k in reversed(bulles):
        canv.delete(k)
    texte.append(canv.create_text(400,200,text='Opération terminée',font=('Arial',30),fill='green'))
    if positif!=0:
        signe="+"
        couleur = 'red'
    elif negatif!=0:
        signe = "-"
        couleur='blue'
    else:
        signe=""
        couleur='grey'
    valabs=str(positif+negatif)
    if n1[0] not in "+-":
        n1="+"+str(n1)
    if n2[0] not in "+-":
        n2="+"+str(n2)
    texte.append(canv.create_text(300,400,text='Donc (' +str(n1)+') + ('+str(n2)+ ') = (' +signe+valabs +')',font=('Arial',20),fill='black'))
    fenetre.after(7000,start)

def init(n1,n2):
    global delai,rayon,noStart,intro,negatif, positif,debut,fin
    positif,negatif=0,0
    noStart=False
    debut=time()
    canv.delete(intro)
    n1 = float(n1)
    n2 = float(n2)
    delai=100
    if n1 < 0:
        n1=int(-n1)
        negatif += n1
        couleur1='blue'
    else:
        n1=int(n1)
        positif+=n1
        couleur1='red'
    if n2 < 0:
        n2=-int(n2)
        negatif+=n2
        couleur2='blue'
    else:
        n2 = int(n2)
        positif+=n2
        couleur2='red'
    rayon = int(150/(abs(max(negatif,positif))))
    if couleur1=='red':
        texte.append(canv.create_text(400,300,text='Les boules rouges représentent les nombres positifs',font=('Arial',14),fill='red'))
    else:
        texte.append(canv.create_text(400,300,text='Les boules bleues représentent les nombres négatifs',font=('Arial',14),fill='blue'))
    for k in range(n1):
        blop.play()
        creerBulle(50+k*round(750/n1),200,couleur1,6)
        canv.update()
        sleep(0.5)
    canv.delete(texte[-1])    
    if couleur2=='red':
        texte.append(canv.create_text(400,300,text='Les boules rouges représentent les nombres positifs',font=('Arial',14),fill='red'))
    else:
        texte.append(canv.create_text(400,300,text='Les boules bleues représentent les nombres négatifs',font=('Arial',14),fill='blue'))
    for k in range(n2):
        blop.play()
        creerBulle(50+k*round(750/n2),500,couleur2,7)
        canv.update()
        sleep(0.5)
    print('pos: ',positif,'  neg: ',negatif)
    canv.delete(texte[-1])
    animer()

def attente():
    global noStart
    if noStart:
        canv.update()
        fenetre.after(500,attente)

def valider():
    global n1, n2
    n1=nombre1.get()
    n2=nombre2.get()
    bouton.place_forget()
    nombre1.place_forget()
    nombre2.place_forget()
    init(n1,n2)

def start():
    global compteur, liste,intro,tour,noStart,vitinit,texte,perdu,rayon,balle,bulles,xBulle,yBulle,vxBulle,vyBulle,rayonBulle,couleurBulle,tempsVie
    compteur, positif,negatif,tour =0,0,0,0
    for k in texte:
        canv.delete(k)
    noStart=True
    perdu=False
    rayon=20
    xBalle,yBalle=400,300
    liste,texte,bulles,xBulle,yBulle,vxBulle,vyBulle,couleurBulle=[],[],[],[],[],[],[],[]
    vitinit=2
    intro=canv.create_text(400,500,text='Saisissez les nombres à  additionner dans les cases puis Cliquez sur Valider.',font=('arial',10),fill='purple')
    nombre1.place(x=200,y=200)
    nombre2.place(x=500,y=200)
    bouton.place(x=350,y=400)
    attente()

fenetre=Tk()
fenetre.geometry('800x600')
#img=PhotoImage(file='fondBulles.gif')
canv=Canvas(fenetre,height=600,width=800)
#canv.create_image(400,300,image=img)
canv.place(x=0,y=0)
perdu=False
noStart=True
rayon=20
negatif,positif=0,0
delai=50
xBalle,yBalle=400,300
pygame.mixer.pre_init(44100,-16,2,2048)
pygame.mixer.init()
blop=pygame.mixer.Sound('blop2.ogg')
scrunch=pygame.mixer.Sound('scrunch.ogg')
toc=pygame.mixer.Sound('teic.ogg')
nom=''
liste,texte,bulles,xBulle,yBulle,vxBulle,vyBulle,rayonBulle,couleurBulle,tempsVie=[],[],[],[],[],[],[],[],[],[]
nombre1=Entry(fenetre,width=6,font=('Arial',20))
nombre2=Entry(fenetre,width=6,font=('Arial',20))
bouton=Button(fenetre,text='valider',font=('Arial',20),command=valider)
VX,VY,vitinit=0,0,2
debut=0
fin=time()+30
start()
fenetre.mainloop()